## httraqt 1.2.0

=== CMakeLists.txt ===
PROJECT(httraqt)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(SET CMP0003 OLD)

# INCLUDE(CPack)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(TestCXXAcceptsFlag)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(FindPkgConfig)

# SET(TARGET_NAME httraqt )

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

INCLUDE(HTTRAQTOutOfSourceBuild) # Disallow in-source builds
INCLUDE(HTTRAQTGenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(HTTRAQTDependencies)
INCLUDE(HTTRAQTWordSize) # Detect 32/64 bit platform
INCLUDE(HTTRAQTCompiler) # Detect problematic compilers

# Set the HTTraQt version
#cat README | grep -E  '^[0-9]+\.[0-9]+\.[0-9]+' | head -n 1
EXECUTE_PROCESS (
   COMMAND cat README
   COMMAND grep -E  "^[0-9]+\\.[0-9]+\\.[0-9]+"
   COMMAND head -n 1
   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
   RESULT_VARIABLE HTTQTVERSION
   OUTPUT_VARIABLE DESCRIBE_STRING
   OUTPUT_STRIP_TRAILING_WHITESPACE)
     
IF(NOT DESCRIBE_STRING)
        SET(DESCRIBE_STRING "no valid git tag for ${PROJECT_NAME} found")
ELSE()
        STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" HTTRAQT_VERSION "${DESCRIBE_STRING}" )
        IF (NOT HTTRAQT_VERSION)
                SET(DESCRIBE_STRING "no valid git tag ${PROJECT_NAME}-x.x.x found")
        ENDIF()
ENDIF()

MESSAGE("-- Version info: ${HTTRAQT_VERSION}") 
SET(VERSION ${HTTRAQT_VERSION})

EXECUTE_PROCESS (
      COMMAND date +"%d %b %Y"
      COMMAND sed -e "s/\"//g"
      OUTPUT_VARIABLE BUILD_DATE
      OUTPUT_STRIP_TRAILING_WHITESPACE)

MESSAGE("-- Version build date: ${BUILD_DATE}")

configure_file (
  "${PROJECT_SOURCE_DIR}/sources/version.h.in"
  "${PROJECT_SOURCE_DIR}/sources/version.h" )

# here parse the VERSION
# SET(HTTRAQT_MAJOR_VERSION 1)
# SET(HTTRAQT_MINOR_VERSION 0)
# SET(HTTRAQT_RELEASE_VERSION 14)
# SET(HTTRAQT_BUILD_VERSION 0)
# SET(HTTRAQT_SO_VERSION 1)

SET(HTTRAQT_PACKAGE httraqt)
# SET(HTTRAQT_VERSION ${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}.${HTTRAQT_RELEASE_VERSION}.${HTTRAQT_BUILD_VERSION})
SET(HTTRAQT_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(HTTRAQT_COPYRIGHT "Copyright (c) 2012-2013, Eduard Kalinowski. All Rights Reserved.")
SET(HTTRAQT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Setup high-level build options
IF(WIN32 AND MSVC)
	SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
ELSE(WIN32 AND MSVC)
	SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
ENDIF(WIN32 AND MSVC)

FIND_PACKAGE(Qt4 REQUIRED)


INCLUDE(FindQt4)
IF(NOT QT4_FOUND)
    MESSAGE(FATAL_ERROR "Qt4 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
ENDIF(NOT QT4_FOUND)

INCLUDE(HTTRAQTFindHttrack)

SET( HTTRACK_INCLUDES_DIR "" )


INCLUDE_DIRECTORIES(${QT_INCLUDES})
MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
LINK_DIRECTORIES(${QT_LIBRARY_DIR})
MESSAGE(STATUS "QT_LIBRARY_DIR ${QT_LIBRARY_DIR}")

SET ( OBJECTS_DIR temp )
SET ( MOC_DIR temp )
SET ( UI_HEADERS_DIR temp )
SET ( UI_SOURCES_DIR temp )

ADD_SUBDIRECTORY(sources/main)
ADD_SUBDIRECTORY(sources/options)
ADD_SUBDIRECTORY(sources/icons)

INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR}  ${CMAKE_SOURCE_DIR} $(CMAKE_CURRENT_SOURCE_DIR)/sources/options/includes $(CMAKE_CURRENT_SOURCE_DIR)/sources/main/includes )

#QT4_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
QT4_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
QT4_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
QT4_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})

INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR} ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

SOURCE_GROUP( "Generated Files" FILES
    ${MOC_FILES_CPP}
    ${APP_FORMS_HEADERS}
    ${APP_RESOURCES_RCC}
)

INCLUDE(${QT_USE_FILE})
ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_PROJECT -DNO_QT3SUPPORT -DDISABLE_QT3SUPPORT)
#REMOVE_DEFINITIONS(-DQT3_SUPPORT)
#SET(QT_QT3SUPPORT_INCLUDE_DIR OFF)

ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
    ${APP_SOURCES} 
#    ${HTTRACK_SOURCES}
    ${MAIN_SOURCES}
    ${OPT_SOURCES}
    ${APP_HEADERS_MOC} 
    ${APP_FORMS_HEADERS} 
    ${APP_RESOURCES_RCC}
)

TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} httrack)

ADD_CUSTOM_TARGET (tags
    COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/sources/main ${CMAKE_SOURCE_DIR}/sources/options
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
# MESSAGE("CMAKE_SOURCE_DIR main ${CMAKE_SOURCE_DIR}")
# MESSAGE("CMAKE_CURRENT_BINARY_DIR main ${CMAKE_CURRENT_BINARY_DIR}")
# INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


# Setup module enabled/disabled defaults ...
IF(WIN32)
	SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
	SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
	SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(WIN32)

IF(UNIX AND NOT APPLE)
	SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
	SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
	SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
	SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
	SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT ON)
	SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(APPLE)


OPTION(HTTRAQT_ENABLE_SYMBOL_VISIBILITY "Minimize the number of symbols exported from shared libraries." ${HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT})
MARK_AS_ADVANCED(HTTRAQT_ENABLE_SYMBOL_VISIBILITY)

# OPTION(HTTRAQT_ENABLE_TESTING "Build the HTTraQt regression test suite." OFF)
# SET(BUILD_TESTING ${HTTRAQT_ENABLE_TESTING} CACHE INTERNAL "" FORCE)
# INCLUDE(CTest)
# MARK_AS_ADVANCED(DART_TESTING_TIMEOUT)
# IF(HTTRAQT_ENABLE_TESTING)
# 	CMAKE_MINIMUM_REQUIRED(VERSION 2.6.1 FATAL_ERROR)
# 	CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake @ONLY)
# ENDIF(HTTRAQT_ENABLE_TESTING)

# Find required external packages
HTTRAQT_CHECK_REQUIRED_DEPENDENCY(HTTRAQT_HTTRACK_FOUND "libhttrack2" "http://www.httrack.com" "")
# HTTRAQT_CHECK_OPTIONAL_DEPENDENCY(HTTRAQT_BUILD_3DS_IO_MODULE HTTRAQT_3DS_FOUND "lib3ds")

# Capture system configuration
INCLUDE(HTTRAQTSystemConfiguration)

# Win32 configuration
IF(WIN32)
	IF(NOT MSVC)
		SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc" CACHE STRING "" FORCE)
		SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
	ENDIF(NOT MSVC)
ENDIF(WIN32)

# Setup output directories ...
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)

SET(HTTRAQT_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
IF(WIN32)
	SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)
ELSE(WIN32)
	SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/${HTTRAQT_LIBDIR})
ENDIF(WIN32)

# Setup a macro for compiling resources ...
MACRO(HTTRAQT_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)

	SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
	SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
	GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)

	GET_TARGET_PROPERTY(HTTRAQT_RESOURCE_COMPILER httraqt-resource-compiler LOCATION)

	ADD_CUSTOM_COMMAND(
		DEPENDS httraqt-resource-compiler
		DEPENDS ${INPUT_FILE}
		COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
		COMMAND ${HTTRAQT_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
		OUTPUT ${OUTPUT_FILE}
		COMMENT "Compiling resource ${INPUT_FILE}"
		)

	LIST(APPEND ${OUTPUT} ${OUTPUT_FILE})

ENDMACRO(HTTRAQT_COMPILE_RESOURCE)

# Setup subdirectories ...
HTTRAQT_CONDITIONAL_BUILD(MSVC gendef)

OPTION(HTTRAQT_ENABLE_DISTRIBUTION "Enable distribution targets." ON)
HTTRAQT_CONDITIONAL_BUILD(HTTRAQT_ENABLE_DISTRIBUTION distribution)

# Hide some cruft ...
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)
MARK_AS_ADVANCED(CMAKE_EXECUTABLE_FORMAT)
MARK_AS_ADVANCED(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES)
MARK_AS_ADVANCED(CMAKE_OSX_DEPLOYMENT_TARGET)
MARK_AS_ADVANCED(CMAKE_OSX_SYSROOT)
MARK_AS_ADVANCED(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_USE_CHRPATH)

=== sources/main/CMakeLists.txt ===
#CMakeLists.txt

set(MAIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/httraqt.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/AboutDialog.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/buttonPanel.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ConfirmTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/FinalTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/htinterface.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/InsertUrlDialog.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/NewProjTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/OptionsTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ProgressTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/StartTab.cpp
                PARENT_SCOPE)

set(MAIN_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/includes/httraqt.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/lang.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/AboutDialog.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/buttonPanel.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/FinalTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/../version.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/htsnet.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/htsstrings.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/InsertUrlDialog.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/NewProjTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/ProgressTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/ConfirmTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/htinterface.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/OptionsTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/StartTab.h
                PARENT_SCOPE)


set(MAIN_FORMS  ${CMAKE_CURRENT_SOURCE_DIR}/forms/AboutDialog.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/buttonPanel.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/ConfirmTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/FinalTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/InsertUrlDialog.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/mainForm.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/NewProjTab.ui 
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/ProgressTab.ui 
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/StartTab.ui
                PARENT_SCOPE)

#QT4_WRAP_CPP(MAIN_HEADERS_MOC ${MAIN_HEADERS})
#QT4_WRAP_UI(MAIN_FORMS_HEADERS ${MAIN_FORMS})

# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== sources/options/CMakeLists.txt ===
#CMakeLists.txt

set(OPT_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/optionsbrowser.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsbuild.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/OptionsDialog.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/BuildStringDialog.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsexperts.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsflow.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionslimits.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionslinks.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionslog.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsmime.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsproxy.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsrulez.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsspider.cpp
                PARENT_SCOPE)

set(OPT_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsbrowser.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsbuild.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/OptionsDialog.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/BuildStringDialog.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsexperts.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsflow.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionslimits.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionslinks.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionslog.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsmime.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsproxy.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsrulez.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsspider.h
                PARENT_SCOPE)


set(OPT_FORMS ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsBrowser.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsBuild.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/BuildStringDialog.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsDialog.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsExperts.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsFlow.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsLimits.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsLinks.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsLog.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsMime.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsProxy.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsRulez.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsSpider.ui
                PARENT_SCOPE)


QT4_WRAP_CPP(OPT_HEADERS_MOC ${OPT_HEADERS})
QT4_WRAP_UI(OPT_FORMS_HEADERS ${OPT_FORMS})

# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== debian/changelog ===
httraqt (1.2.0-1) unstable; urgency=low

  * Initial packaging. (Closes: #733448).

 -- Anton Gladky <gladk@debian.org>  Sun, 29 Dec 2013 22:18:46 +0100

=== debian/control ===
Source: httraqt
Section: web
Priority: optional
Maintainer: Anton Gladky <gladk@debian.org>
Homepage: http://httraqt.sourceforge.net/
Standards-Version: 3.9.5
Build-Depends:
 cmake,
 debhelper (>= 9),
 libhttrack-dev,
 libqt4-dev,
 libssl-dev
Vcs-Git: git://anonscm.debian.org/collab-maint/httraqt.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/httraqt.git

Package: httraqt
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: program for downloading of internet sites
 Program is intended for loading of Internet pages and/or their contents,
 equipped with flexible system of settings.
 HTTraQt - graphical user interface (GUI) for HTTrack library,
 developed in C++ and based on multiplatform Qt library.

## httraqt 1.3.0

=== CMakeLists.txt ===
PROJECT(httraqt)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(SET CMP0003 OLD)
CMAKE_POLICY(SET CMP0015 OLD)

# if you use the version 5, please change it to 5
SET(USE_QT_VERSION 4)

MESSAGE("Qt version for compiling: " ${USE_QT_VERSION})

IF(NOT ${USE_QT_VERSION} MATCHES "4" AND NOT ${USE_QT_VERSION} MATCHES "5")
    MESSAGE(FATAL_ERROR "-- Qt version must be set to 4 or 5!")
ENDIF()

# INCLUDE(CPack)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(TestCXXAcceptsFlag)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(FindPkgConfig)

# SET(TARGET_NAME httraqt )

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

INCLUDE(HTTRAQTOutOfSourceBuild) # Disallow in-source builds
INCLUDE(HTTRAQTGenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(HTTRAQTDependencies)
INCLUDE(HTTRAQTWordSize) # Detect 32/64 bit platform
INCLUDE(HTTRAQTCompiler) # Detect problematic compilers

# Set the HTTraQt version
#cat README | grep -E  '^[0-9]+\.[0-9]+\.[0-9]+' | head -n 1
EXECUTE_PROCESS (
   COMMAND cat README
   COMMAND grep -E  "^[0-9]+\\.[0-9]+\\.[0-9]+"
   COMMAND head -n 1
   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
   RESULT_VARIABLE HTTQTVERSION
   OUTPUT_VARIABLE DESCRIBE_STRING
   OUTPUT_STRIP_TRAILING_WHITESPACE)


IF(NOT DESCRIBE_STRING)
        SET(DESCRIBE_STRING "no valid git tag for ${PROJECT_NAME} found")
ELSE()
        STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" HTTRAQT_VERSION "${DESCRIBE_STRING}" )
        IF (NOT HTTRAQT_VERSION)
                SET(DESCRIBE_STRING "no valid git tag ${PROJECT_NAME}-x.x.x found")
        ENDIF()
ENDIF()

MESSAGE("-- Version info: ${HTTRAQT_VERSION}") 
SET(VERSION ${HTTRAQT_VERSION})

EXECUTE_PROCESS (
      COMMAND date +"%d %b %Y"
      COMMAND sed -e "s/\"//g"
      OUTPUT_VARIABLE BUILD_DATE
      OUTPUT_STRIP_TRAILING_WHITESPACE)

MESSAGE("-- Version build date: ${BUILD_DATE}")

configure_file (
  "${PROJECT_SOURCE_DIR}/sources/version.h.in"
  "${PROJECT_SOURCE_DIR}/sources/version.h" )

# 
SET(HTTRAQT_PACKAGE httraqt)
# SET(HTTRAQT_VERSION ${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}.${HTTRAQT_RELEASE_VERSION}.${HTTRAQT_BUILD_VERSION})
SET(HTTRAQT_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(HTTRAQT_COPYRIGHT "Copyright (c) 2012-2014, Eduard Kalinowski. All Rights Reserved.")
SET(HTTRAQT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Setup high-level build options
IF(WIN32 AND MSVC)
    SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
ELSE(WIN32 AND MSVC)
    SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
ENDIF(WIN32 AND MSVC)


IF(${USE_QT_VERSION} MATCHES "4")
    FIND_PACKAGE(Qt4 REQUIRED)

    INCLUDE(FindQt4)
    IF(NOT QT4_FOUND)
        MESSAGE(FATAL_ERROR "Qt4 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF(NOT QT4_FOUND)
ELSE()
    FIND_PACKAGE (Qt5Widgets)
    FIND_PACKAGE (Qt5Multimedia)
    FIND_PACKAGE (Qt5DBus)

    IF(NOT Qt5Widgets_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF(NOT Qt5Widgets_FOUND)
ENDIF()


INCLUDE(HTTRAQTFindHttrack)

SET( HTTRACK_INCLUDES_DIR "" )

IF(${USE_QT_VERSION} MATCHES "4")
  INCLUDE_DIRECTORIES(${QT_INCLUDES})
    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
    LINK_DIRECTORIES(${QT_LIBRARY_DIR})
    MESSAGE(STATUS "QT_LIBRARY_DIR ${QT_LIBRARY_DIR}")
ELSE()
    INCLUDE_DIRECTORIES(${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS})
    MESSAGE(STATUS "QT_INCLUDES  ${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS}")
#     LINK_DIRECTORIES(${Qt5Core_LIBRARIES}, ${Qt5Multimedia_LIBRARIES}, ${Qt5DBus_LIBRARIES}, ${Qt5Widgets_LIBRARIES})
#     MESSAGE(STATUS "QT_LIBRARY_DIR ${Qt5Core_LIBRARIES}, ${Qt5Multimedia_LIBRARIES}, ${Qt5DBus_LIBRARIES}, ${Qt5Widgets_LIBRARIES}")
    SET(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
ENDIF()

SET ( OBJECTS_DIR temp )
SET ( MOC_DIR temp )
SET ( UI_HEADERS_DIR temp )
SET ( UI_SOURCES_DIR temp )

SET ( QT_USE_QTDBUS 1 )
  
ADD_SUBDIRECTORY(sources/main)
ADD_SUBDIRECTORY(sources/options)
ADD_SUBDIRECTORY(sources/icons)


INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR}  ${CMAKE_SOURCE_DIR} $(CMAKE_CURRENT_SOURCE_DIR)/sources/options/includes $(CMAKE_CURRENT_SOURCE_DIR)/sources/main/includes )

IF(${USE_QT_VERSION} MATCHES "4")
    #QT4_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT4_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT4_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
    QT4_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ELSE()
    #QT5_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT5_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT5_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
    QT5_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ENDIF()


INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR} ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

SOURCE_GROUP( "Generated Files" FILES
    ${MOC_FILES_CPP}
    ${APP_FORMS_HEADERS}
    ${APP_RESOURCES_RCC}
)

IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE(${QT_USE_FILE})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_PROJECT -DNO_QT3SUPPORT -DDISABLE_QT3SUPPORT)
ELSE()
    ADD_DEFINITIONS( ${Qt5Widgets_DEFINITIONS})
ENDIF()

ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
    ${APP_SOURCES} 
    ${MAIN_SOURCES}
    ${OPT_SOURCES}
    ${APP_HEADERS_MOC} 
    ${APP_FORMS_HEADERS} 
    ${APP_RESOURCES_RCC}
)


IF(${USE_QT_VERSION} MATCHES "4")
    TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} httrack)
ELSE()
    TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${Qt5Widgets_LIBRARIES} ${Qt5DBus_LIBRARIES} httrack)
ENDIF()

ADD_CUSTOM_TARGET (tags
    COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/sources/main ${CMAKE_SOURCE_DIR}/sources/options
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
# MESSAGE("CMAKE_SOURCE_DIR main ${CMAKE_SOURCE_DIR}")
# MESSAGE("CMAKE_CURRENT_BINARY_DIR main ${CMAKE_CURRENT_BINARY_DIR}")
# INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


# Setup module enabled/disabled defaults ...
IF(WIN32)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(WIN32)

IF(UNIX AND NOT APPLE)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT ON)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(APPLE)


OPTION(HTTRAQT_ENABLE_SYMBOL_VISIBILITY "Minimize the number of symbols exported from shared libraries." ${HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT})
MARK_AS_ADVANCED(HTTRAQT_ENABLE_SYMBOL_VISIBILITY)

# OPTION(HTTRAQT_ENABLE_TESTING "Build the HTTraQt regression test suite." OFF)
# SET(BUILD_TESTING ${HTTRAQT_ENABLE_TESTING} CACHE INTERNAL "" FORCE)
# INCLUDE(CTest)
# MARK_AS_ADVANCED(DART_TESTING_TIMEOUT)
# IF(HTTRAQT_ENABLE_TESTING)
#     CMAKE_MINIMUM_REQUIRED(VERSION 2.6.1 FATAL_ERROR)
#     CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake @ONLY)
# ENDIF(HTTRAQT_ENABLE_TESTING)

# Find required external packages
HTTRAQT_CHECK_REQUIRED_DEPENDENCY(HTTRAQT_HTTRACK_FOUND "libhttrack2" "http://www.httrack.com" "")
# HTTRAQT_CHECK_OPTIONAL_DEPENDENCY(HTTRAQT_BUILD_3DS_IO_MODULE HTTRAQT_3DS_FOUND "lib3ds")

# Capture system configuration
INCLUDE(HTTRAQTSystemConfiguration)

# Win32 configuration
IF(WIN32)
    IF(NOT MSVC)
        SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc" CACHE STRING "" FORCE)
        SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF(NOT MSVC)
ENDIF(WIN32)

# Setup output directories ...
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)

SET(HTTRAQT_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
IF(WIN32)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)
ELSE(WIN32)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/${HTTRAQT_LIBDIR})
ENDIF(WIN32)

# Setup a macro for compiling resources ...
MACRO(HTTRAQT_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)

    SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
    SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
    GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)

    GET_TARGET_PROPERTY(HTTRAQT_RESOURCE_COMPILER httraqt-resource-compiler LOCATION)

    ADD_CUSTOM_COMMAND(
        DEPENDS httraqt-resource-compiler
        DEPENDS ${INPUT_FILE}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
        COMMAND ${HTTRAQT_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
        OUTPUT ${OUTPUT_FILE}
        COMMENT "Compiling resource ${INPUT_FILE}"
        )

    LIST(APPEND ${OUTPUT} ${OUTPUT_FILE})

ENDMACRO(HTTRAQT_COMPILE_RESOURCE)

# Setup subdirectories ...
HTTRAQT_CONDITIONAL_BUILD(MSVC gendef)

OPTION(HTTRAQT_ENABLE_DISTRIBUTION "Enable distribution targets." ON)
HTTRAQT_CONDITIONAL_BUILD(HTTRAQT_ENABLE_DISTRIBUTION distribution)

# Hide some cruft ...
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)
MARK_AS_ADVANCED(CMAKE_EXECUTABLE_FORMAT)
MARK_AS_ADVANCED(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES)
MARK_AS_ADVANCED(CMAKE_OSX_DEPLOYMENT_TARGET)
MARK_AS_ADVANCED(CMAKE_OSX_SYSROOT)
MARK_AS_ADVANCED(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_USE_CHRPATH)

=== distribution/osx/CMakeLists.txt ===
#OPTION(HTTRAQT_INSTALL_AQSIS "Include Aqsis in the K-3D installer" OFF)
#OPTION(HTTRAQT_INSTALL_CGKIT "Include cgkit in the K-3D installer" OFF)
#OPTION(HTTRAQT_INSTALL_PYGTK "Include PyGTK in the K-3D installer" OFF)
#OPTION(HTTRAQT_INSTALL_PYOPENGL "Include PyOpenGL in the K-3D installer" OFF)
#OPTION(HTTRAQT_INSTALL_PYTHON "Include Python in the K-3D installer" ON)
OPTION(HTTRAQT_CREATE_PACKAGEMAKER_PACKAGE "Include an option to build a MacOSX PackageMaker package." OFF)

SET(HTTRAQT_BINARY_LOCATIONS )
LIST(APPEND HTTRAQT_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/httraqt")
LIST(APPEND HTTRAQT_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/httraqt-make-module-proxy")
LIST(APPEND HTTRAQT_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/httraqt-renderframe")
LIST(APPEND HTTRAQT_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/httraqt-renderjob")
LIST(APPEND HTTRAQT_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/httraqt-resource-compiler")
LIST(APPEND HTTRAQT_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/httraqt-sl2xml")
LIST(APPEND HTTRAQT_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/httraqt-uuidgen")

FILE(GLOB_RECURSE HTTRAQT_PLUGIN_BINARIES "${HTTRAQT_BINARY_DIR}/${HTTRAQT_LIBDIR}/httraqt/plugins/*.module")
LIST(APPEND HTTRAQT_BINARY_LOCATIONS ${HTTRAQT_PLUGIN_BINARIES})

# Enable automatic installation of library dependencies ...
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake" @ONLY)
INSTALL(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake")

# Install some runtime dependencies that can't be detected via static analysis ...

# This is an ugly hack, we should be able to detect this automatically, but I'm feeling lazy ...
SET(HTTRAQT_MACPORTS_DIR "/opt/local" CACHE PATH "Root directory containing installed MacPorts packages")
MARK_AS_ADVANCED(HTTRAQT_MACPORTS_DIR)

INSTALL(
	PROGRAMS
		${HTTRAQT_MACPORTS_DIR}/lib/libgailutil.18.dylib
	DESTINATION
		lib
	)

INSTALL(
	DIRECTORY
		${HTTRAQT_MACPORTS_DIR}/lib/gtk-2.0/2.10.0
	DESTINATION
		lib/gtk-2.0
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${HTTRAQT_MACPORTS_DIR}/lib/gtk-2.0/modules
	DESTINATION
		lib/gtk-2.0/2.10.0
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${HTTRAQT_MACPORTS_DIR}/lib/pango
	DESTINATION
		lib
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${HTTRAQT_MACPORTS_DIR}/etc/gtk-2.0
		${HTTRAQT_MACPORTS_DIR}/etc/fonts
		${HTTRAQT_MACPORTS_DIR}/etc/pango
	DESTINATION
		etc
	)

# Bundle packaging is always available ...
ADD_SUBDIRECTORY(bundle)

# We optionally support creating packagemaker packages ...
IF(HTTRAQT_CREATE_PACKAGEMAKER_PACKAGE)
	ADD_SUBDIRECTORY(packagemaker)
ENDIF(HTTRAQT_CREATE_PACKAGEMAKER_PACKAGE)

=== distribution/source/CMakeLists.txt ===
SET(HTTRAQT_PACKAGE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
FILE(MAKE_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}")

# Generate source packages
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-source-tbz2.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-source-tbz2.cpack)
ADD_CUSTOM_TARGET(package-source-tbz2
	WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
	COMMAND ${CMAKE_CPACK_COMMAND} --config "${CMAKE_CURRENT_BINARY_DIR}/package-source-tbz2.cpack"
	)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-source-tgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-source-tgz.cpack)
ADD_CUSTOM_TARGET(package-source-tgz
	WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
	COMMAND ${CMAKE_CPACK_COMMAND} --config "${CMAKE_CURRENT_BINARY_DIR}/package-source-tgz.cpack"
	)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-source-zip.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-source-zip.cpack)
ADD_CUSTOM_TARGET(package-source-zip
	WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
	COMMAND ${CMAKE_CPACK_COMMAND} --config "${CMAKE_CURRENT_BINARY_DIR}/package-source-zip.cpack"
	)

# Upload source packages to SourceForge
# ADD_CUSTOM_TARGET(upload-package-source-tbz2
# 	DEPENDS "${HTTRAQT_PACKAGE_DIRECTORY}/${HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.bz2"
# 	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
# 	COMMAND rsync -e ssh -R --progress --protect-args "HTTraQt ${HTTRAQT_VERSION}/${HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.bz2" "${HTTRAQT_SOURCEFORGE_USERNAME},k3d@frs.sourceforge.net:/home/frs/project/k/k3/k3d/HTTraQt Source/"
# 	)
# 
# ADD_CUSTOM_TARGET(upload-package-source-tgz
# 	DEPENDS "${HTTRAQT_PACKAGE_DIRECTORY}/${HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz"
# 	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
# 	COMMAND rsync -e ssh -R --progress --protect-args "HTTraQt ${HTTRAQT_VERSION}/${HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz" "${HTTRAQT_SOURCEFORGE_USERNAME},k3d@frs.sourceforge.net:/home/frs/project/k/k3/k3d/HTTraQt Source/"
# 	)
# 
# ADD_CUSTOM_TARGET(upload-package-source-zip
# 	DEPENDS "${HTTRAQT_PACKAGE_DIRECTORY}/${HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME}.zip"
# 	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
# 	COMMAND rsync -e ssh -R --progress --protect-args "HTTraQt ${HTTRAQT_VERSION}/${HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME}.zip" "${HTTRAQT_SOURCEFORGE_USERNAME},k3d@frs.sourceforge.net:/home/frs/project/k/k3/k3d/HTTraQt Source/"
# 	)

=== sources/main/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #CMakeLists.txt
 
-set(MAIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/httraqt.cpp
+set(MAIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/translator.cpp
+                 ${CMAKE_CURRENT_SOURCE_DIR}/httraqt.cpp
                  ${CMAKE_CURRENT_SOURCE_DIR}/AboutDialog.cpp
                  ${CMAKE_CURRENT_SOURCE_DIR}/buttonPanel.cpp
                  ${CMAKE_CURRENT_SOURCE_DIR}/ConfirmTab.cpp
@@ -15,7 +16,7 @@
                 PARENT_SCOPE)
 
 set(MAIN_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/includes/httraqt.h
-                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/lang.h
+                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/translator.h
                  ${CMAKE_CURRENT_SOURCE_DIR}/includes/AboutDialog.h
                  ${CMAKE_CURRENT_SOURCE_DIR}/includes/buttonPanel.h
                  ${CMAKE_CURRENT_SOURCE_DIR}/includes/FinalTab.h
@@ -47,6 +48,7 @@
 #QT4_WRAP_CPP(MAIN_HEADERS_MOC ${MAIN_HEADERS})
 #QT4_WRAP_UI(MAIN_FORMS_HEADERS ${MAIN_FORMS})
 
+
 # cleanup $build/*.cpp~ on "make clean"
 SET_DIRECTORY_PROPERTIES(PROPERTIES
     ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== sources/options/CMakeLists.txt ===
--- 
+++ 
@@ -46,9 +46,15 @@
 	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsSpider.ui
                 PARENT_SCOPE)
 
-
-QT4_WRAP_CPP(OPT_HEADERS_MOC ${OPT_HEADERS})
-QT4_WRAP_UI(OPT_FORMS_HEADERS ${OPT_FORMS})
+# IF(${USE_QT_VERSION} MATCHES "4")
+#     QT4_WRAP_CPP(OPT_HEADERS_MOC ${OPT_HEADERS})
+#     QT4_WRAP_UI(OPT_FORMS_HEADERS ${OPT_FORMS})
+# ENDIF()
+# 
+# IF(${USE_QT_VERSION} MATCHES "5")
+#     QT5_WRAP_CPP(OPT_HEADERS_MOC ${OPT_HEADERS})
+#     QT5_WRAP_UI(OPT_FORMS_HEADERS ${OPT_FORMS})
+# ENDIF()
 
 # cleanup $build/*.cpp~ on "make clean"
 SET_DIRECTORY_PROPERTIES(PROPERTIES

=== debian/changelog ===
httraqt (1.3.0-1) unstable; urgency=medium

  * [21d0560] Imported Upstream version 1.3.0

 -- Anton Gladky <gladk@debian.org>  Fri, 31 Jan 2014 19:57:07 +0100

httraqt (1.2.2-1) unstable; urgency=medium

  * [df79bef] Imported Upstream version 1.2.2

 -- Anton Gladky <gladk@debian.org>  Thu, 23 Jan 2014 19:47:53 +0100

httraqt (1.2.1-1) unstable; urgency=medium

  * [687f3bb] Imported Upstream version 1.2.1

 -- Anton Gladky <gladk@debian.org>  Sat, 04 Jan 2014 23:03:48 +0100

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

override_dh_installchangelogs:
	dh_installchangelogs README

=== debian/watch ===
version=3
http://sf.net/httraqt/httraqt-([\d.]+)\.tar\.gz debian uupdate

## httraqt 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -132,7 +132,7 @@
   
 ADD_SUBDIRECTORY(sources/main)
 ADD_SUBDIRECTORY(sources/options)
-ADD_SUBDIRECTORY(sources/icons)
+#ADD_SUBDIRECTORY(sources/icons)
 
 
 INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR}  ${CMAKE_SOURCE_DIR} $(CMAKE_CURRENT_SOURCE_DIR)/sources/options/includes $(CMAKE_CURRENT_SOURCE_DIR)/sources/main/includes )

=== sources/icons/CMakeLists.txt ===
#CMakeLists.txt

set(APP_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/application.qrc
                PARENT_SCOPE)

# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== debian/changelog ===
httraqt (1.4.4-1) unstable; urgency=medium

  * [b710f90] Imported Upstream version 1.4.4

 -- Anton Gladky <gladk@debian.org>  Fri, 25 Jul 2014 23:25:15 +0200

httraqt (1.4.3-1) unstable; urgency=medium

  * [853a145] Imported Upstream version 1.4.3

 -- Anton Gladky <gladk@debian.org>  Tue, 10 Jun 2014 23:35:47 +0200

httraqt (1.3.2-1) unstable; urgency=medium

  * [d7782ee] Imported Upstream version 1.3.2

 -- Anton Gladky <gladk@debian.org>  Mon, 28 Apr 2014 19:30:15 +0200

httraqt (1.3.1-1) unstable; urgency=medium

  * [be7896b] Imported Upstream version 1.3.1

 -- Anton Gladky <gladk@debian.org>  Sun, 23 Mar 2014 07:18:08 +0100

## httraqt 1.4.6

=== debian/changelog ===
httraqt (1.4.6-2) unstable; urgency=medium

  * [3c3588e] Take build date from d/changelog. Towards reproducibility.

 -- Anton Gladky <gladk@debian.org>  Mon, 07 Sep 2015 18:39:13 +0200

httraqt (1.4.6-1) unstable; urgency=medium

  * [284a7cf] Imported Upstream version 1.4.6
  * [a52f714] Switch to Qt5.

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Sep 2015 21:22:30 +0200

httraqt (1.4.5-1) unstable; urgency=medium

  * [f7792bd] Imported Upstream version 1.4.5
  * [d5dd257] Standards-Version: 3.9.6. No changes.
  * [8509702] Update d/copyright.
  * [7c6636f] Apply cme fix dpkg-control.

 -- Anton Gladky <gladk@debian.org>  Sat, 05 Sep 2015 22:04:12 +0200
